summaryrefslogtreecommitdiffstats
path: root/rt2570
diff options
context:
space:
mode:
author Eric Hameleers <alien@slackware.com>2008-05-30 17:16:08 +0000
committer Eric Hameleers <alien@slackware.com>2008-05-30 17:16:08 +0000
commitc6e7e0a2ed213daa5c8479e99e872158b6c17906 (patch)
tree93764c418cf5d734f238d6b83acada1dacf30606 /rt2570
parent33111771bf1b8079601a215662cec9c810a6b517 (diff)
downloadasb-c6e7e0a2ed213daa5c8479e99e872158b6c17906.tar.gz
asb-c6e7e0a2ed213daa5c8479e99e872158b6c17906.tar.xz
Initial revision
Diffstat (limited to 'rt2570')
-rwxr-xr-xrt2570/build/rt2570.SlackBuild251
-rw-r--r--rt2570/build/slack-desc19
2 files changed, 270 insertions, 0 deletions
diff --git a/rt2570/build/rt2570.SlackBuild b/rt2570/build/rt2570.SlackBuild
new file mode 100755
index 00000000..b9f1ff27
--- /dev/null
+++ b/rt2570/build/rt2570.SlackBuild
@@ -0,0 +1,251 @@
+#!/bin/sh
+# $Id$
+# Copyright (c) 2008 Eric Hameleers <alien@slackware.com>
+# All rights reserved.
+#
+# Permission to use, copy, modify, and distribute this software for
+# any purpose with or without fee is hereby granted, provided that
+# the above copyright notice and this permission notice appear in all
+# copies.
+#
+# THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+# IN NO EVENT SHALL THE AUTHORS AND COPYRIGHT HOLDERS AND THEIR
+# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+# USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
+# ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
+# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
+# OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+# -----------------------------------------------------------------------------
+#
+# Slackware SlackBuild script
+# ===========================
+# By: Eric Hameleers <alien@slackware.com>
+# For: rt2570
+# Descr: driver for RaLink based wireless cards
+# URL: http://rt2x00.sourceforge.net/
+# Needs:
+# Changelog:
+# 20080530-1: 30/may/2008 by Eric Hameleers <alien@slackware.com>
+# * Initial build
+#
+# Run 'sh rt2570.SlackBuild --cleanup' to build a Slackware package.
+# The package (.tgz) plus descriptive .txt file are created in /tmp .
+# Install using 'installpkg'.
+#
+# -----------------------------------------------------------------------------
+
+# Set initial variables:
+
+PRGNAM=rt2570
+ARCH=${ARCH:-i486}
+BUILD=${BUILD:-1}
+TAG=${TAG:-alien}
+
+# If you use a CVS daily tarball, the VERSION string will be
+# determined from the tarball content. VERSION will look like YYYYMMDD
+# If USE_CVS == "no" then the script will use SRCVER and VERSION values below.
+USE_CVS=${USE_CVS:-"yes"}
+
+if [ "$USE_CVS" == "yes" ]; then
+ SRCVER="cvs-daily"
+ VERSION="cvs-daily"
+else
+ SRCVER=1.1.0-b2
+ VERSION=$( echo ${SRCVER} | tr '-' '.' )
+fi
+
+DOCS="CHANGELOG FAQ LICENSE THANKS ./Module/iwpriv_usage.txt \
+ ./Module/TESTING README.module"
+
+# Where do we look for sources?
+SRCDIR=$(cd $(dirname $0); pwd)
+
+# Place to build (TMP) package (PKG) and output (OUTPUT) the program:
+TMP=${TMP:-/tmp/build}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+# Kernel module related parameters:
+KVER=${KVER:-`uname -r`}
+KSRC=${KSRC:-/lib/modules/${KVER}/build}
+PATCHLEVEL=`echo $KVER|cut -f 2 -d '.'`
+[ $PATCHLEVEL -eq 4 ] && MODCONFFILE=modules.conf || MODCONFFILE=modprobe.conf
+
+# Input URL: http://rt2x00.serialmonkey.com/rt2570-cvs-daily.tar.gz
+SOURCE="$SRCDIR/${PRGNAM}-${VERSION}.tar.gz"
+if [ "$USE_CVS" == "yes" ]; then
+ SRCURL="http://rt2x00.serialmonkey.com/${PRGNAM}-cvs-daily.tar.gz"
+else
+ SRCURL="http://downloads.sourceforge.net/rt2400/${PRGNAM}-${SRCVER}.tar.gz"
+fi
+
+##
+## --- with a little luck, you won't have to edit below this point --- ##
+##
+
+# Exit the script on errors:
+set -e
+trap 'echo "$0 FAILED at line $LINENO!" | tee $OUTPUT/error-${PRGNAM}.log' ERR
+# Catch unitialized variables:
+set -u
+P1=${1:-1}
+
+# Slackware 11 and up need other option (gcc > 3.3.x)
+if [ `gcc -dumpversion | tr -d '.' |cut -c 1-2` -gt 33 ]; then
+ MOPT=tune
+else
+ MOPT=cpu
+fi
+
+case "$ARCH" in
+ i486) SLKCFLAGS="-O2 -march=i486 -m${MOPT}=i686"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ s390) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ powerpc) SLKCFLAGS="-O2"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+ x86_64) SLKCFLAGS="-O2 -fPIC"
+ SLKLDFLAGS="-L/usr/lib64"; LIBDIRSUFFIX="64"
+ ;;
+ athlon-xp) SLKCFLAGS="-march=athlon-xp -O3 -pipe -fomit-frame-pointer"
+ SLKLDFLAGS=""; LIBDIRSUFFIX=""
+ ;;
+esac
+
+# Create working directories:
+mkdir -p $TMP/tmp-$PRGNAM # location to build the source
+rm -rf $TMP/tmp-$PRGNAM/* # remove the remnants of previous build
+mkdir -p $PKG # place for the package to be built
+rm -rf $PKG/* # erase old package's contents
+mkdir -p $OUTPUT # place for the package to be saved
+
+# Source file availability:
+if ! [ -f ${SOURCE} ]; then
+ if ! [ "x${SRCURL}" == "x" ]; then
+ # Check if the $SRCDIR is writable at all - if not, download to $OUTPUT
+ [ -w "$SRCDIR" ] || SOURCE="$OUTPUT/`basename $SOURCE`"
+ echo "Source '`basename ${SOURCE}`' not available yet..."
+ echo "Will download file to `dirname $SOURCE`"
+ wget -nv -T 30 -O "${SOURCE}" "${SRCURL}" || true
+ if [ $? -ne 0 -o ! -s "${SOURCE}" ]; then
+ echo "Downloading '`basename ${SOURCE}`' failed... aborting the build."
+ mv -f "${SOURCE}" "${SOURCE}".FAIL
+ exit 1
+ fi
+ else
+ echo "File '`basename ${SOURCE}`' not available... aborting the build."
+ exit 1
+ fi
+fi
+
+if [ "$P1" == "--download" ]; then
+ echo "Download complete."
+ exit 0
+fi
+
+# --- PACKAGE BUILDING ---
+
+echo "++"
+echo "|| $PRGNAM-$VERSION"
+echo "++"
+
+cd $TMP/tmp-$PRGNAM
+echo "Extracting the source archive(s) for $PRGNAM..."
+tar -xvf ${SOURCE}
+if [ -d ${PRGNAM}-${SRCVER} ]; then
+ mv ${PRGNAM}-${SRCVER} ${PRGNAM}-${VERSION}
+else
+ echo -n "Changing VERSION from '$VERSION' to "
+ VERSION=$(tar -tf $SOURCE | head -1 | cut -d- -f3 | cut -c 1-8)
+ echo "'$VERSION'"
+ mv ${PRGNAM}-cvs-${VERSION}* ${PRGNAM}-${VERSION}
+fi
+cd ${PRGNAM}-${VERSION}
+chown -R root:root .
+chmod -R u+w,go+r-w,a-s .
+
+echo Building ...
+( cd Module
+ CFLAGS="$SLKCFLAGS" \
+ CXXFLAGS="$SLKCFLAGS" \
+ LDFLAGS="$SLKLDFLAGS" \
+ make debug KERNDIR=$KSRC PATCHLEVEL=$PATCHLEVEL \
+ 2>&1 | tee $OUTPUT/make-${PRGNAM}.log
+)
+
+# Install all the needed stuff to the package dir
+mkdir -p $PKG/lib/modules/${KVER}/drivers/net/wireless
+cp -a Module/${PRGNAM}.ko $PKG/lib/modules/${KVER}/drivers/net/wireless/
+
+# Add this to the doinst.sh:
+! [ -d $PKG/install ] && mkdir -p $PKG/install
+cat <<-EEOOTT >> $PKG/install/doinst.sh
+ # Only run depmod on matching running kernel
+ # Slackware will run depmod anyway on reboot):
+ MYMODVER=$KVER
+ MYKERNEL=\`uname -r\`
+ if [ "\$MYKERNEL" = "\$MYMODVER" ]; then
+ if [ -x sbin/depmod ]; then
+ chroot . /sbin/depmod -a \$MYKERNEL 1> /dev/null 2> /dev/null
+ fi
+ fi
+
+ # Determine the rc.modules to use:
+ if [ -f etc/rc.d/rc.modules.local ]; then
+ RCMODULES="etc/rc.d/rc.modules.local"
+ elif [ -f etc/rc.d/rc.modules-$(uname -r) ]; then
+ RCMODULES="etc/rc.d/rc.modules-$(uname -r)"
+ else
+ RCMODULES="etc/rc.d/rc.modules"
+ fi
+
+ # Make sure the module gets loaded on boot:
+ if ! grep -q "$PRGNAM" \${RCMODULES} ; then
+ echo "" >> \${RCMODULES}
+ echo "# Load the kernel module" >> \${RCMODULES}
+ echo "/sbin/modprobe $PRGNAM" >> \${RCMODULES}
+ fi
+
+ EEOOTT
+
+# Add documentation:
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a ./Module/README README.module
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION || true
+cp -a $SRCDIR/$(basename $0) $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+find $PKG/usr/doc -type f -exec chmod 644 {} \;
+
+# Compress the man page(s):
+if [ -d $PKG/usr/man ]; then
+ find $PKG/usr/man -type f -name "*.?" -exec gzip -9f {} \;
+ for i in `find $PKG/usr/man -type l -name "*.?"` ; do ln -s $( readlink $i ).gz $i.gz ; rm $i ; done
+fi
+
+# Add a package description:
+mkdir -p $PKG/install
+cat $SRCDIR/${PRGNAM}.slack-desc > $PKG/install/slack-desc
+if [ -f $SRCDIR/doinst.sh ]; then
+ cat $SRCDIR/doinst.sh >> $PKG/install/doinst.sh
+fi
+
+# Build the package:
+cd $PKG
+makepkg --linkadd y --chown n $OUTPUT/${PRGNAM}-${VERSION}_$(echo $KVER | tr - _)-${ARCH}-${BUILD}${TAG}.tgz 2>&1 | tee $OUTPUT/makepkg-${PRGNAM}.log
+cd $OUTPUT
+md5sum ${PRGNAM}-${VERSION}_$(echo $KVER | tr - _)-${ARCH}-${BUILD}${TAG}.tgz > ${PRGNAM}-${VERSION}_$(echo $KVER | tr - _)-${ARCH}-${BUILD}${TAG}.tgz.md5
+cd -
+cat $PKG/install/slack-desc | grep "^${PRGNAM}" > $OUTPUT/${PRGNAM}-${VERSION}_$(echo $KVER | tr - _)-${ARCH}-${BUILD}${TAG}.txt
+
+# Clean up the extra stuff:
+if [ "$P1" = "--cleanup" ]; then
+ rm -rf $TMP/tmp-$PRGNAM
+ rm -rf $PKG
+fi
diff --git a/rt2570/build/slack-desc b/rt2570/build/slack-desc
new file mode 100644
index 00000000..7b559a0d
--- /dev/null
+++ b/rt2570/build/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|'
+# on the right side marks the last column you can put a character in. You must
+# make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+rt2570: rt2570 (driver for RaLink 802.11g)
+rt2570:
+rt2570: RaLink rt2570 is a chipset for 802.11g USB wireless cards.
+rt2570: The rt2570 driver supports cards based on this chipset in Linux.
+rt2570:
+rt2570:
+rt2570:
+rt2570:
+rt2570:
+rt2570: rt2570 project info at http://rt2x00.serialmonkey.com/
+rt2570: